class Pettanr.PettanrCreativeCommonsV30Licenses
  @new_attribute: (params = {}) ->
    new PettanrCreativeCommonsV30Licenses.Attribute(params)
  
class Pettanr.PettanrCreativeCommonsV30Licenses.License extends Backbone.Model
  # OMG... this model is not petanized item
  # it means that can't change name
  base_name: () ->
    "pettanr_creative_commons_v30_licenses"
  
  baseName: () ->
    "PettanrCreativeCommonsV30Licenses"
  
  item_name: () ->
    @base_name() + '/license'
  
  table_name: () ->
    @base_name() + '/licenses'
  
  singular: () ->
    @baseName() + '/License'
  
  plural: () ->
    @baseName() + '/Licenses'
  
  engine_name: () ->
    @table_name()
  
  form_name: () ->
    @engine_name() + '/licenses'

class Pettanr.PettanrCreativeCommonsV30Licenses.CreditPicture extends Backbone.Model
  # OMG... this model is not petanized item
  # it means that can't change name
  base_name: () ->
    "pettanr_creative_commons_v30_licenses"
  
  baseName: () ->
    "PettanrCreativeCommonsV30Licenses"
  
  item_name: () ->
    @base_name() + '/credit_picture'
  
  table_name: () ->
    @base_name() + '/credit_pictures'
  
  singular: () ->
    @baseName() + '/CreditPicture'
  
  plural: () ->
    @baseName() + '/CreditPictures'
  
  engine_name: () ->
    @table_name()
  
  form_name: () ->
    @engine_name() + '/credit_pictures'

class Pettanr.PettanrCreativeCommonsV30Licenses.Attribute extends Backbone.Model
  # OMG... this model is not petanized item
  # it means that can't change name
  base_name: () ->
    "pettanr_creative_commons_v30_licenses"
  
  baseName: () ->
    "PettanrCreativeCommonsV30Licenses"
  
  item_name: () ->
    @base_name() + '/attribute'
  
  table_name: () ->
    @base_name() + '/attributes'
  
  singular: () ->
    @baseName() + '/Attribute'
  
  plural: () ->
    @baseName() + '/Attributes'
  
  engine_name: () ->
    @table_name()
  
  form_name: () ->
    @engine_name() + '/attributes'

class Pettanr.PettanrCreativeCommonsV30Licenses.LicenseModule
  supply_default: () ->
    super()
    @license_group_classname = @license_group.get('classname')
  
  license_extend: () ->
    @new_license() if not @lex
    @lex
  
  license_extend_setter: (params) ->
    # load attributes
    @lex = new Pettanr.PettanrCreativeCommonsV30Licenses.License(params)
    # no supply default params
  
  new_license: (params = {}) -> 
    @lex = new Pettanr.PettanrCreativeCommonsV30Licenses.License(params)
    @lex.supply_default()
  
class Pettanr.PettanrCreativeCommonsV30Licenses.CreditPictureModule
  supply_default: () ->
    super()
  
  credit_picture_extend: () ->
    @new_credit_picture() if not @crex
    @crex
  
  credit_picture_extend_setter: (params) ->
    # load attributes
    @crex = new Pettanr.PettanrCreativeCommonsV30Licenses.CreditPicture(params)
    # no supply default params
  
  new_credit_picture: (params = {}) -> 
    @crex = new Pettanr.PettanrCreativeCommonsV30Licenses.CreditPicture(params)
    @crex.supply_default()
  
class Pettanr.PettanrCreativeCommonsV30Licenses.AttributeModule
  supply_default: () ->
    super()
  
  attribute_extend: () ->
    @attrex
  
  attribute_extend_setter: (params) ->
    # load attributes
    @attrex = Pettanr.PettanrCreativeCommonsV30Licenses.new_attribute(params)
    # no supply default params
  
