class Pettanr.Views.GroundColor.NewElementLauncher extends Editor.EditorModule.DockModule.NewElementLauncher
  
  initialize: (options) ->
    super(options)
    @links_conf = {
      inspire: {
        caption: 'Inspire',
        params: {
          controller: @model.path_name(), action: 'index',
          page_size: 6, format: 'html'
        }
      }
    }
  
  render: () ->
    super()
    @pick_icon = new Pettanr.Views.Common.PickIcon({name: 'pick'})
    @listenTo(@pick_icon, 'click', @pick_click)
    this.$el.append(@pick_icon.render().el)
    @add_links()
    this
  
  pick_click: () ->
    model = @model
    new_item = new model()
    # new_item.set({}, {silent: true})
    @pick(new_item)
  
  click_inspire: () ->
    @click_default(@links_conf.inspire.params)
  
class Pettanr.Views.GroundColor.NewElement extends Backbone.View
  
  initialize: (options) ->
    @parent = options.parent
    @target_model = options.target_model
  
  start: (@dialog, params) ->
    @dialog.start(@target_model, params, null)
    @listenTo(@dialog, 'pick', @pick)
    @trigger('dialog:open', @dialog)
  
  pick: (item) ->
    new_item = new @target_model(item.attributes)
    new_item.unset('id', {silent: true})
    new_item.set({panel_id: @editor().item.get('id')}, {silent: true})
    @dialog.stop()
    @trigger('pick', new_item)
  
  dock: () ->
    @parent.dock()
  
  editor: () ->
    @dock().editor()
  
