class Pettanr.Views.GroundPicture.NewElementLauncher extends Editor.EditorModule.DockModule.NewElementLauncher
  
  initialize: (options) ->
    super(options)
    @links_conf = {
      resource_picture: {
        caption: 'Resource Picture',
        params: {
          controller: @model.pick_model().path_name(), action: 'index',
          page_size: 6, format: 'html'
        }
      }
    }
  
  render: () ->
    super()
    @add_links()
    this
  
  click_resource_picture: () ->
    @click_default(@links_conf.resource_picture.params)
  
class Pettanr.Views.GroundPicture.NewElement extends Backbone.View
  
  initialize: (options) ->
    @parent = options.parent
    @target_model = options.target_model
    @pick_model = @target_model.pick_model()
  
  start: (@dialog, params) ->
    @dialog.start(@target_model, params, null)
    @listenTo(@dialog, 'pick', @pick)
    @trigger('dialog:open', @dialog)
  
  pick: (item) ->
    if item.item_name() == @target_model.item_name()
      # Inspire
      @listenTo(this, 'ready', @ready)
      new_item = new @target_model(item.attributes)
      new_item.unset('id', {silent: true})
      new_item.set({panel_id: @editor().item.get('id')}, {silent: true})
      @trigger('ready', new_item)
    else if @target_model.is_traceable(item.item_name())
      # Trace
      tracer_class = @target_model['TraceFrom' + item.singular()]
      tracer = new tracer_class()
      @listenTo(tracer, 'trace', @trace)
      tracer.trace(item)
    else if item.item_name() == @target_model.pick_item_name()
      # Pick  resource_picture to ground_picture
      @listenTo(this, 'ready', @ready)
      new_item = new @target_model()
      new_item.set(new_item.pick(item), {silent: true})
      @trigger('ready', new_item)
  
  ready: (new_item) ->
    @dialog.stop()
    @trigger('pick', new_item)
  
  trace: (resource_picture) ->
    @dialog.http_get(resource_picture.show_url())
  
  dock: () ->
    @parent.dock()
  
  editor: () ->
    @dock().editor()
  
