class Pettanr.Views.ResourcePicture.ShowModule
class Pettanr.Views.ResourcePicture.ShowModule.Header extends Pettanr.Views.Show.Header
  
  initialize: (options) ->
    super(options)
  
class Pettanr.Views.ResourcePicture.ShowModule.Owner extends Pettanr.Views.Show.Owner
  
  initialize: (options) ->
    super(options)
  
class Pettanr.Views.ResourcePicture.Show extends Backbone.View
  tagName: 'div'
  className: 'show'
  
  initialize: (options) ->
    @item = options.item
    @header = new Pettanr.Views.ResourcePicture.ShowModule.Header({
      item: @item, 
      icon_url: @item.show_url(),
      caption_url: @item.show_url(),
      prof_url: @item.prof_url()
    })
    @artist = new Pettanr.Views.Show.HeaderArtist({item: @item})
    @listenTo(@header, 'click:pick', @click_pick)
    @listenTo(@header, 'click:icon', @click_show)
    @listenTo(@header, 'click:prof', @click_prof)
    @listenTo(@artist, 'click:artist', @click_artist)
  
  render: () ->
    this.$el.html('')
    this.$el.append(@header.render().el)
    this.$el.append(@artist.render().el)
    this
  
  click_show: () ->
    @trigger('http_get', @item.show_url())
  
  click_prof: () ->
    @trigger('http_get', @item.prof_url())
  
  click_artist: () ->
    @trigger('http_get', @item.artist().show_url())
  
  click_pick: () ->
    @trigger('pick', @item)
  
  is_pickable: () ->
    true
  
  add_pick: (target_model) ->
    @header.add_pick(target_model)
  
