class ProvidersController < ApplicationController
  before_filter :authenticate_admin!, :only => [:index, :show, :destroy]

  def index
    @page = Provider.page params[:page]
    @page_size = Provider.page_size params[:page_size]
    @hide = params[:hide]
    @providers = if @hide.blank?
      Provider.list(@page, @page_size)
    else
      Provider.available_list(@page, @page_size)
    end

    respond_to do |format|
      format.html # index.html.erb
      format.json { render :json => @providers.to_json(Provider.list_json_opt) }
    end
  end

  def show
    @provider = Provider.show(params[:id], @admin)

    respond_to do |format|
      format.html # show.html.erb
      format.json { render :json => @provider.to_json(Provider.show_json_opt) }
    end
  end

  def destroy
  end
  
end
