require_dependency "locmare/filer/body/file_body/file_item/symbol"
require_dependency "locmare/filer/body/file_body/file_item/caption"
require_dependency "locmare/filer/body/file_body/file_item/summary"
require_dependency "locmare/filer/body/file_body/file_item/icon"
require_dependency "locmare/filer/body/file_body/file_item/date"
require_dependency "locmare/filer/body/file_body/file_item/edit"
module Locmare
  module FilerModule
    module BodyModule
      module FileBodyModule
        class FileItem
          include FileItemModule
          
          attr :file_body, :item, 
            :symbol, :caption, :summary, :icon, :date, :edit
          def initialize file_body, item
            @file_body = file_body
            @item = item
            @symbol = SymbolItemColumnFactory.factory self, self.filer.manifest.symbol, @item
            @caption = CaptionItemColumnFactory.factory self, self.filer.manifest.caption, @item
            @summary = SummaryItemColumnFactory.factory self, self.filer.manifest.summary, @item
            @icon = IconItemColumnFactory.factory self, self.filer.manifest.icon, @item
            @date = DateItemColumnFactory.factory self, self.filer.manifest.date, @item
            @edit = EditItemColumnFactory.factory self, self.filer.manifest.edit, @item
          end
          
          def filer
            @file_body.filer
          end
          
          def manifest
            self.filer.manifest
          end
          
          def item_name
            self.filer.item_name
          end
          
          def model
            self.filer.model
          end
          
          def items
            self.filer.items
          end
          
          def template_dir
            self.filer.template_dir
          end
          
          def template_file_name
            "file_item"
          end
          
          def template_name
            self.template_dir + self.template_file_name
          end
          
        end
      end
    end
  end
end
