require_dependency "locmare/profiler/header"
require_dependency "locmare/profiler/column"
require_dependency "locmare/profiler/association"
module Locmare
  class Profiler
    include ProfilerModule
    attr :profiler_manifest, :item_name, :item, :operators, :template_dir, 
      :header, :columns, :associations
    def initialize item_name, item, operators
      @item_name = item_name
      @item = item
      @operators = operators
      # feasible show parsed extend data
      @item.boosts 'post'
      
      @profiler_manifest = LocalManifest.manifest.profilers[@item_name]
      @template_dir = 'templates/r/profiler/'
      @header = Header.new self
      @columns = {}
      @profiler_manifest.columns.each {|name, column|
        @columns[name] = Column.factory self, column
      }
      @associations = Association.new self, @profiler_manifest.associations
    end
    
    def each_column
      @profiler_manifest.column_names.each {|column_name|
        yield @columns[column_name]
      }
    end
    
    def peta
      Manifest.manifest.items[@item_name]
    end
    
    def model
      ::Manifest::item_name_to_model @item_name
    end
    
    def template_file_name
      "profiler"
    end
    
    def template_name
      self.template_dir + self.template_file_name
    end
    
    def header_template_file_name
      "header"
    end
    
    def header_template_name
      self.template_dir + self.header_template_file_name
    end
    
    def columns_template_file_name
      "columns"
    end
    
    def columns_template_name
      self.template_dir + self.columns_template_file_name
    end
    
    def associations_template_file_name
      "associations"
    end
    
    def associations_template_name
      self.template_dir + self.associations_template_file_name
    end
    
    def image_dir
      '/images/'
    end
    
  end
end

