module Manifest
  module SystemResourceModule
    class Template
      def self.manager system_resource, my_manifests
        templates = {}
        my_manifests.each {|template_name, my_manifest|
          templates[template_name] = self.new(system_resource, template_name, my_manifest)
        }
        templates
      end
      
      attr :template_name, :my_manifest, :path_name, 
        :template_items, :has_route
      def initialize system_resource, template_name, my_manifest
        @system_resource = system_resource
        @template_name = template_name
        @my_manifest = my_manifest
        self.set_default
        self.init
      end
      
      def set_default
        @my_manifest['template_items'] ||= {}
        @my_manifest['has_route'] ||= 1
      end
      
      def init
        @has_route = @my_manifest['has_route']
        @template_items = @my_manifest['template_items']
      end
      
      def add_route?
        @has_route > 0
      end
      
    end
  end
end

